Defeaturing Tools: how to edit a STEP model (parametrically)

Info about new community or project announcements, implemented features, classes, modules or APIs. Might get technical!
PLEASE DO NOT POST HELP REQUESTS OR OTHER DISCUSSIONS HERE!
User avatar
easyw-fc
Posts: 2087
Joined: Thu Jul 09, 2015 9:34 am

Re: Defeaturing Tools: first attempt (how to edit a STEP model)

Postby easyw-fc » Tue Aug 14, 2018 2:56 pm

wmayer wrote:
Tue Aug 14, 2018 12:51 pm
In which Freecad version the new features will be integrated?
It must be in +/- 0.18.14224
would it possible to have Part Box selection for Faces acting as the object selection? with a selective behavior left <=> right & right <=> left?
Maurice
wmayer wrote:
Fri Sep 29, 2017 6:16 am
So in addition to the "normal" selection which is currently there I'd like to add a selection that selects the whole object when it's only touched on one corner/line/point.
It could be switched like in SolidWorks where it depends if you make the selection bottom to top or top to bottom (not sure which was which).
This is already implemented with the difference that it's not top <=> bottom/bottom <=> top but left <=> right/right <=> left.
User avatar
easyw-fc
Posts: 2087
Joined: Thu Jul 09, 2015 9:34 am

Re: Defeaturing Tools: first attempt (how to edit a STEP model)

Postby easyw-fc » Tue Sep 25, 2018 9:07 pm

new tool: Parametric Defeaturing... :D

phpBB [video]


This tool is quite sensible to "topological naming" issues, but it can be tricked to manually edit the Faces in case of reordering.
triplus
Posts: 7640
Joined: Mon Dec 12, 2011 4:45 pm

Re: Defeaturing Tools: how to edit a STEP model (parametrically)

Postby triplus » Wed Sep 26, 2018 6:51 pm

Always nice to see such progress.
User avatar
easyw-fc
Posts: 2087
Joined: Thu Jul 09, 2015 9:34 am

Re: Defeaturing Tools: how to edit a STEP model (parametrically)

Postby easyw-fc » Tue Oct 09, 2018 2:37 pm

Just added a new feature:
Fuzzy Boolean operation [Cut, Union, Common]
fuzzy-boolean-ops.png
fuzzy-boolean-ops.png (48.78 KiB) Viewed 466 times
sdaau_ml
Posts: 12
Joined: Fri Dec 07, 2018 12:18 am

Re: Defeaturing Tools: first attempt (how to edit a STEP model)

Postby sdaau_ml » Tue Dec 11, 2018 5:09 pm

Hi, thanks for this;

I just managed to have a build with OCC 0.7.3:

Code: Select all

OS: Ubuntu 18.04.1 LTS
Word size of OS: 64-bit
Word size of FreeCAD: 64-bit
Version: 0.18.15379 (Git)
Build type: Release
Branch: master
Hash: 3290c36d28551875f02333c2e01af80e38b8ad02
Python version: 2.7.15rc1
Qt version: 4.8.7
Coin version: 4.0.0a
OCC version: 7.3.0
Locale: English/UnitedStates (en_US)
, and I tried this:
freecad-heini-1 wrote:
Fri Aug 03, 2018 1:47 pm
My new video concerning the new defeaturing tool from the Part workbench:
https://peertube.mastodon.host/videos/w ... d8e6783872

I tried to use PeerTube, not bad for the first test.
The video is in German language.
... but no matter how many faces I have selected, I get:

Code: Select all

>>> sh = App.getDocument('test').Shell.Shape
>>> nsh = sh.defeaturing([sh.Face6,])
>>> if not sh.isPartner(nsh):
>>> 		defeat = App.ActiveDocument.addObject('Part::Feature','Defeatured').Shape = nsh
>>> 		Gui.ActiveDocument.Shell.hide()
>>> else:
>>> 		FreeCAD.Console.PrintError('Defeaturing failed\n')
>>> App.ActiveDocument.recompute()
...
Exception (Tue Dec 11 18:02:10 2018): Error: There are no enough arguments to perform the operation
  
Shell: Error: There are no enough arguments to perform the operation
Any ideas what I could be doing wrong? As I understood, one can just select faces in a single object of many faces, and then click "Defeaturing"/"Remove feature from a shape" - and that would be it, faces would be deleted?
User avatar
NormandC
Posts: 17276
Joined: Sat Feb 06, 2010 9:52 pm
Location: Québec, Canada

Re: Defeaturing Tools: how to edit a STEP model (parametrically)

Postby NormandC » Wed Dec 12, 2018 2:41 am

There is one essential rule: from the selection of faces to delete, it must be possible to rebuild a solid. Take a simple cube for example: you cannot delete any face because the defeaturing tool couldn't rebuild a solid. Now if your cube has a hole in it, then you can select the inner cylindrical face and the hole will be "plugged in".